--
-- ProfiLua
-- Example #7
--
-- A little (and not that nice to read) clock state machine.
--
-- (c) ASkr, www.askrprojects.net
--

gNumInputs  = 4
gNumOutputs = 2

InputNames  = {"clkUp","timesUp","clkDown","timesDown"}
OutputNames = {"Up","Down"}

function gInputName(channel)
	return InputNames[channel]
end

function gOutputName(channel)
	return OutputNames[channel]
end

function gSimStart(In)
	return {1,1}
end

function gSimStop(In)
end



outUp       = gHIGH  -- global logic marker, UP
outDown     = gHIGH  -- global logic marker, DOWN

outUpLeft   = 0      -- number of clock edges left, UP
outDownLeft = 0      -- number of clock edges left, DOWN

butstat     = 0      -- button state (has to be release before next action)

-- states:
--   0 - nothing
--   1 - clock  UP low
--   2 - clock  UP high
--   3 - repeat UP
--  11 - clock  DOWN low
--  12 - clock  DOWN high
--  13 - repeat DOWN
state   = 0







------------------------------------------------------------------------------
-- NewState
--
--
------------------------------------------------------------------------------
function NewState()
	-- clock UP low
	if state == 1 then
		outUp = gLOW
		outUpLeft = outUpLeft - 1
		state = state + 1 

	-- clock UP high
	elseif state == 2 then
		outUp = gHIGH
		state = state + 1 
		
	-- repeat UP
	elseif state == 3 then
		if outUpLeft == 0 then
			state = 0
		else
			state = 1
		end
		
	-- clock DOWN low
	elseif state == 11 then
		outDown = gLOW
		outDownLeft = outDownLeft - 1
		state = state + 1 

	-- clock DOWN high
	elseif state == 12 then
		outDown = gHIGH
		state = state + 1 
		
	-- repeat DOWN
	elseif state == 13 then
		if outDownLeft == 0 then
			state = 0
		else
			state = 11
		end
		
	end
end


------------------------------------------------------------------------------
-- gCalulate
--
--
------------------------------------------------------------------------------
function gCalculate(In)

	if state > 0 then
		NewState()
	else

		-- avoid triggering all the time; button has to be released
		if butstat ~= 0 then
			if In[1] == gLOW and In[3] == gLOW then
				butstat = 0
			end
		
		else
		
			-- check if UP button clicked
			if In[1] >= gISHIGH then
				if In[2] > 0 then
					outUpLeft = In[2]
					state = 1
					butstat = 1
				end
			
			-- check if DOWN button clicked
			elseif In[3] >= gISHIGH then
				if In[4] > 0 then
					outDownLeft = In[4]
					state = 11
					butstat = 1
				end
			end

		end -- end else butstat
	
	end -- end else (state == 0)
	
	
	return {outUp,outDown}
end

