--
-- ProfiLua
--
-- Simple datalogger and formatted write operations (to file) demo
--
--
-- (c) ASkr, www.askrprojects.net
--


gNumInputs  = 5
gNumOutputs = 2

InputNames  = {"CH1_d_3","CH2_x_4","CH3_f_6.1","CH4_b_32","log on"}
OutputNames = {"file open","written"}


function gInputName(channel)
	return InputNames[channel]
end

function gOutputName(channel)
	return OutputNames[channel]
end


filename = "logger.log"
separator = ' '
fout = nil
written = 0


------------------------------------------------------------------------------
-- gSimStart
--
-- 
------------------------------------------------------------------------------
function gSimStart(In)

	-- change "w" to "a" if data should be appended
	fout = io.open(filename,"w")
	
	if fout == nil then
		return {gLOW, written}
	else
		return {gHIGH, written}
	end

end



------------------------------------------------------------------------------
-- gSimStop
--
-- 
------------------------------------------------------------------------------
function gSimStop(In)
	
	if fout ~= nil then
		fout:close()
	end
	
end



------------------------------------------------------------------------------
-- gCalculate
--
-- 
------------------------------------------------------------------------------
function gCalculate(In)
	local i
	
	if fout ~= nil and In[5] >= gISHIGH then
		-- In[1]: decimal, leading " ", 3 digits
		fout:write(string.format("%3d",In[1])..separator)
		-- In[2]: hex, leading "0", 4 digits
		fout:write(string.format("%04x",In[2])..separator)
		-- In[3]: float, leading " ", 3.1 digits
		fout:write(string.format("%6.1f",In[3])..separator)
		-- In[4]: binary, leading " ", 32 digits
		fout:write(string.format("%s","0b"..probit.tobin(In[4],32)))
		fout:write("\n")
		written = written + 1
	end
	
	if fout == nil then
		return {gLOW, written}
	else
		return {gHIGH, written}
	end
	
end
